<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <style>
        body {
            margin: 0;
        }

        ul.sidebarMenu {
            list-style-type: none;
            margin: 0;
            padding: 0;
            width: 200px;
            background-color: #f1f1f1;
            border: 1px solid #555;
            position: fixed;
            height: 100%;
            overflow: auto;
        }

        li.sidebarMenu {
            text-align: center;
            border-bottom: 1px solid #555;
        }

        li a.sidebarMenu {
            text-align: center;
            border-bottom: 1px solid #555;
        }

        li a.active.sidebarMenu {
            background-color: #04AA6D;
            color: white;
        }

        li a.sidebarMenu:hover:not(.active) {
            background-color: #555;
            color: white;
        }
    </style>
</head>

<body>
    <div id="app">

        <!-- Pengganti tag <a href=""></a>  -->
        <ul class="sidebarMenu">
            <li class="sidebarMenu">
                <h3>Belajar Vue Router</h3>
            </li>
            <li class="sidebarMenu">
                <router-link to="/">Home</router-link>
            </li>
            <li class="sidebarMenu">
                <router-link to="/berita">Berita</router-link>
            </li>
            <li class="sidebarMenu">
                <router-link to="/post">Post</router-link>
            </li>
            <li class="sidebarMenu">
                <router-link to="/setting">Setting Role</router-link>
            </li>
        </ul>

        <hr>
        <!-- Untuk Menampilkan component secara dinamis , sesuai dengan route yang diakses -->
        <div style="margin-left:15%;padding:1px 16px;height:500px;">
            <router-view></router-view>
        </div>
    </div>

    <script src="https://unpkg.com/vue/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>

    <script type="module">

        import { CategoriesComponent } from './CategoriesComponent.js'
        import { CategoryComponent } from './CategoryComponent.js'
        import { BeritaComponent } from './BeritaComponent.js'
        import { DetilBeritaComponent } from './DetilBeritaComponent.js'

        // Kita membuat 2 component , yaitu Home dan About
        const Home = { template: '<div>Ini Halaman Home</div>' }
        const Setting = { template: '<div>Ini Halaman Setting</div>' }
        const Post = { template: '<div>Tambah Berita</div>' }

        // Kemudian kita arahkan setiap route ke component yang kita inginkan
        const routes = [
            { path: '/', component: Home, alias: '/home' },
            { path: '/setting', component: Setting, meta: { login: true, is_admin: true } },
            { path: '/post', component: Post, meta: { login: true } },
            { path: '/berita', component: BeritaComponent },
            { path: '/detilBerita/:id', component: DetilBeritaComponent },
            { path: '*', redirect: '/' }
        ]

        //Kemudian kita instansiasi object Vue Router dan tambahkan routes yang sudah kita buat tadi
        const router = new VueRouter({
            routes
        })

        router.beforeEach((to, from, next) => {
            if (to.matched.some(record => record.meta.login)) {

                let auth = true
                if (!auth) {
                    alert('Halaman ini hanya untuk user yang sudah login!')
                    next(false)
                } else {
                    if (to.matched.some(record => record.meta.is_admin)) {
                        let is_admin = false
                        if (!is_admin) {
                            alert('Halaman ini hanya untuk admin!')
                            next(false)
                        } else {
                            next()
                            alert('Berhasil Masuk')
                        }
                    } else {
                        next()
                        alert('Berhasil Masuk')
                    }
                }
            } else {
                next()
            }
        })

        //Kemudian kita tambahkan object VueRouter yang kita namakan router ke object Vue

        var vm = new Vue({
            el: '#app',
            router,
        })
    </script>


</body>

</html>